"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
let ConsoleLogger = ConsoleLogger_1 = class ConsoleLogger {
    constructor(consoleInstance = console) {
        this.consoleInstance = consoleInstance;
    }
    logToConsole(prefix, args) {
        var message = JSON.stringify(args.length ? args[0] : '');
        this.consoleInstance.log(prefix + (message && (ConsoleLogger_1.SEPARATOR + message) || message));
    }
    emergency(...args) {
        this.logToConsole(ConsoleLogger_1.EMERGENCY_PREFIX, args);
    }
    alert(...args) {
        this.logToConsole(ConsoleLogger_1.ALERT_PREFIX, args);
    }
    crit(...args) {
        this.logToConsole(ConsoleLogger_1.CRITICAL_PREFIX, args);
    }
    error(...args) {
        this.logToConsole(ConsoleLogger_1.ERROR_PREFIX, args);
    }
    warning(...args) {
        this.logToConsole(ConsoleLogger_1.WARNING_PREFIX, args);
    }
    notice(...args) {
        this.logToConsole(ConsoleLogger_1.NOTICE_PREFIX, args);
    }
    info(...args) {
        this.logToConsole(ConsoleLogger_1.INFO_PREFIX, args);
    }
    debug(...args) {
        this.logToConsole(ConsoleLogger_1.DEBUG_PREFIX, args);
    }
};
ConsoleLogger.EMERGENCY_PREFIX = "EMERGENCY";
ConsoleLogger.ALERT_PREFIX = "ALERT";
ConsoleLogger.CRITICAL_PREFIX = "CRITICAL";
ConsoleLogger.ERROR_PREFIX = "ERROR";
ConsoleLogger.WARNING_PREFIX = "WARNING";
ConsoleLogger.NOTICE_PREFIX = "NOTICE";
ConsoleLogger.INFO_PREFIX = "INFO";
ConsoleLogger.DEBUG_PREFIX = "DEBUG";
ConsoleLogger.SEPARATOR = ": ";
ConsoleLogger = ConsoleLogger_1 = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.unmanaged()),
    __metadata("design:paramtypes", [Object])
], ConsoleLogger);
exports.ConsoleLogger = ConsoleLogger;
var ConsoleLogger_1;
//# sourceMappingURL=console-logger.js.map