"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const not_specified_param_exception_1 = require("./../../exception/not-specified-param-exception");
const js_helper_1 = require("./../../helper/js-helper");
const inversify_1 = require("inversify");
const inversify_2 = require("inversify");
let DEFAULT_ACTIVATOR_PRIORITY = 0;
let TargetPropertyControllerActivator = TargetPropertyControllerActivator_1 = class TargetPropertyControllerActivator {
    constructor(functionReader, paramsReader, tsHubLogger) {
        this.functionReader = functionReader;
        this.paramsReader = paramsReader;
        this.tsHubLogger = tsHubLogger;
        if (!functionReader) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("functionReader", TargetPropertyControllerActivator_1.name);
        }
        if (!paramsReader) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("paramsReader", TargetPropertyControllerActivator_1.name);
        }
        if (!tsHubLogger) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("tsHubLogger", TargetPropertyControllerActivator_1.name);
        }
    }
    buildControllerActivationMiddleware(target, propertyKey, router, staticData = {}) {
        if (!target) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("target", this.buildControllerActivationMiddleware.name);
        }
        if (!propertyKey) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("propertyKey", this.buildControllerActivationMiddleware.name);
        }
        if (!router) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("router", this.buildControllerActivationMiddleware.name);
        }
        this.tsHubLogger.debug(`Controller activator being built for ${target.constructor.name}.${propertyKey}`);
        var paramBuilders = this.paramsReader.readParameters(target, propertyKey, router) || [];
        let paramsBuilderArray = null;
        let middleware = this.turnIntoMiddleware((...args) => __awaiter(this, void 0, void 0, function* () {
            this.tsHubLogger.debug(`${target.constructor.name}.${propertyKey} being activated`);
            var activatorFunction = this.functionReader.readFunction(target, propertyKey);
            if (!paramsBuilderArray) {
                var paramName = js_helper_1.JsHelper.instance.readFunctionParamNames(target[propertyKey]);
                paramsBuilderArray = [];
                for (let index = 0; index < paramName.length; index++) {
                    var paramBuilder = paramBuilders.find(x => x.getArgumentIndex() == index)
                        || this.createDefaultParameterBuilder(target, propertyKey, paramName[index], index);
                    paramsBuilderArray[index] = paramBuilder.buildParam();
                }
            }
            var params = yield Promise.all(paramsBuilderArray.map(param => param.getValue(staticData, ...args)));
            return activatorFunction(...params);
        }));
        middleware.priority = DEFAULT_ACTIVATOR_PRIORITY;
        return middleware;
    }
};
TargetPropertyControllerActivator = TargetPropertyControllerActivator_1 = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_2.unmanaged()),
    __param(1, inversify_2.unmanaged()),
    __param(2, inversify_2.unmanaged()),
    __metadata("design:paramtypes", [Object, Object, Object])
], TargetPropertyControllerActivator);
exports.TargetPropertyControllerActivator = TargetPropertyControllerActivator;
var TargetPropertyControllerActivator_1;
//# sourceMappingURL=target-property-controller-activator.js.map