"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const middleware_constants_1 = require("./middleware-constants");
const not_specified_param_exception_1 = require("./../../../exception/not-specified-param-exception");
const inversify_1 = require("inversify");
let ConstructorMiddlewareBuilder = ConstructorMiddlewareBuilder_1 = class ConstructorMiddlewareBuilder {
    constructor(activator, tsHubLogger) {
        this.activator = activator;
        this.tsHubLogger = tsHubLogger;
        if (!activator) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("activator", ConstructorMiddlewareBuilder_1.name);
        }
        if (!tsHubLogger) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("tsHubLogger", ConstructorMiddlewareBuilder_1.name);
        }
    }
    withInformation(information) {
        this.information = information;
        return this;
    }
    withTarget(middlewareConstructor) {
        if (!middlewareConstructor) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("middlewareConstructor", ConstructorMiddlewareBuilder_1.name);
        }
        this.middlewareConstructor = middlewareConstructor;
        return this;
    }
    withPropertyKey(propertyKey) {
        this.propertyKey = propertyKey;
        return this;
    }
    withPriority(priority) {
        this.priority = priority;
        return this;
    }
    buildMiddleware(router) {
        if (!router) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("router", this.buildMiddleware.name);
        }
        this.tsHubLogger.debug(`Middleware "${this.middlewareConstructor.prototype.name}" being build.`);
        var middleware = this.activator.buildControllerActivationMiddleware(this.middlewareConstructor.prototype, this.propertyKey || middleware_constants_1.HANDLE_REQUEST, router, { information: this.information });
        middleware.priority = this.priority || middleware_constants_1.DEFAULT_MIDDLEWARE_PRIORITY;
        return middleware;
    }
};
ConstructorMiddlewareBuilder = ConstructorMiddlewareBuilder_1 = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.unmanaged()),
    __param(1, inversify_1.unmanaged()),
    __metadata("design:paramtypes", [Object, Object])
], ConstructorMiddlewareBuilder);
exports.ConstructorMiddlewareBuilder = ConstructorMiddlewareBuilder;
var ConstructorMiddlewareBuilder_1;
//# sourceMappingURL=constructor-middleware-builder.js.map