"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
class RoutedTsFramework {
    constructor(controllerLoader, routeReader, middlewareReader, functionReader, paramsReader) {
        this.controllerLoader = controllerLoader;
        this.routeReader = routeReader;
        this.middlewareReader = middlewareReader;
        this.functionReader = functionReader;
        this.paramsReader = paramsReader;
    }
    setupFramework(container) {
        this.setupRouteReader(container)
            .setupMiddlewareReader(container)
            .setupFunctionReader(container)
            .setupParamsReader(container);
        return this.controllerLoader;
    }
    setupRouteReader(container) {
        this.setupInstance(index_1.Types.RouteReader, this.routeReader, container);
        return this;
    }
    setupMiddlewareReader(container) {
        this.setupInstance(index_1.Types.MiddlewareReader, this.middlewareReader, container);
        return this;
    }
    setupFunctionReader(container) {
        this.setupInstance(index_1.Types.FunctionReader, this.functionReader, container);
        return this;
    }
    setupParamsReader(container) {
        this.setupInstance(index_1.Types.ParamsReader, this.paramsReader, container);
        return this;
    }
    setupInstance(symbol, instance, container) {
        container.bind(symbol).toConstantValue(instance);
    }
}
exports.RoutedTsFramework = RoutedTsFramework;
//# sourceMappingURL=routed-ts-framework.js.map