import { TsHubLogger } from './../../logging/ts-hub-logger';
import { ControllerActivator } from './controller-activator';
import { ParameterBuilder } from './../builder';
import { ParameterReader } from './../reader/parameter-reader';
import { FunctionReader } from './../reader/function-reader';
import { Middleware } from "../middleware";
export declare abstract class TargetPropertyControllerActivator<GenericRouter, RequestHandler> implements ControllerActivator<GenericRouter, RequestHandler> {
    protected functionReader: FunctionReader;
    protected paramsReader: ParameterReader;
    protected tsHubLogger: TsHubLogger;
    constructor(functionReader: FunctionReader, paramsReader: ParameterReader, tsHubLogger: TsHubLogger);
    protected abstract createDefaultParameterBuilder(target: any, propertyKey: string, name: string, index: number): ParameterBuilder<any, GenericRouter>;
    protected abstract turnIntoMiddleware(action: () => Promise<any>): Middleware<any, RequestHandler>;
    buildControllerActivationMiddleware(target: any, propertyKey: string, router: GenericRouter, staticData?: any): Middleware<any, RequestHandler>;
}
