import { ParameterBuilder } from './parameter-builder';
import { ParameterReader } from './../../reader/parameter-reader';
import { Parameter } from '../../parameter';
export declare abstract class DefaultParameterBuilder<Information, GenericRouter> implements ParameterBuilder<Information, GenericRouter> {
    private parameterReader;
    protected information: Information;
    protected target: any;
    protected propertyKey: string;
    protected arg: number;
    constructor(parameterReader: ParameterReader);
    withInformation(information: Information): this;
    getArgumentIndex(): number;
    withTarget(target: any): this;
    withPropertyKey(propertyKey: string): this;
    withArgumentIndex(arg: number): this;
    protected abstract createParameterInstance(): Parameter<Information>;
    abstract supportsRouter(router: GenericRouter): boolean;
    buildParam(): Parameter<Information>;
}
