import { ControllerBuilder, Server, TsHubLogger } from "../../";
import { RoutedController } from "../routed-controller";
import { Middleware } from "../middleware";
import { MiddlewareReader, RouteReader } from "../reader";
import { Route } from "../route";
export declare abstract class RoutedControllerBuilder<Information, GenericRouter, RequestHandler, GenericRoutedController extends RoutedController<Information, GenericRouter, RequestHandler>> implements ControllerBuilder {
    protected middlewareReader: MiddlewareReader;
    protected routeReader: RouteReader;
    protected tsHubLogger: TsHubLogger;
    protected information: Information;
    protected target: any;
    constructor(middlewareReader: MiddlewareReader, routeReader: RouteReader, tsHubLogger: TsHubLogger);
    withInformation(information: Information): this;
    withTarget(target: any): this;
    buildController(): GenericRoutedController;
    abstract supportsServer(server: Server): boolean;
    protected abstract buildRoutedController(): GenericRoutedController;
    protected buildControllerMiddleware(controller: GenericRoutedController): Middleware<any, RequestHandler>[];
    protected buildControllerRoutes(controller: GenericRoutedController): Route<any, GenericRouter, RequestHandler>[];
}
