import { TsHubLogger } from './../logging/ts-hub-logger';
import { TsFramework } from './ts-framework';
import { Server } from "./";
import { HubContainer } from "../";
import { Hub } from "./hub";
import { TsModule } from './ts-module';
export declare class HubBuilder {
    protected supportedServers: Server[];
    protected supportedModules: TsModule[];
    protected tsFramework: TsFramework;
    protected container: HubContainer;
    protected logger: TsHubLogger;
    private static _instance;
    static readonly instance: HubBuilder;
    private constructor();
    withContainer(container: HubContainer): this;
    withLogger(logger: TsHubLogger): this;
    withFramework(tsFramework: TsFramework): this;
    withServerSupport(server: Server): this;
    withModule(module: TsModule): this;
    buildHub(): Hub;
    reset(): void;
    private initializeFramework();
    private initializeLogger();
    private initializeContainer();
}
