import { TsFramework } from './ts-framework';
import { RouteReader, ControllerLoader, MiddlewareReader, FunctionReader, ParameterReader, HubContainer } from '../index';
export declare class RoutedTsFramework implements TsFramework {
    readonly controllerLoader: ControllerLoader;
    readonly routeReader: RouteReader;
    readonly middlewareReader: MiddlewareReader;
    readonly functionReader: FunctionReader;
    readonly paramsReader: ParameterReader;
    constructor(controllerLoader: ControllerLoader, routeReader: RouteReader, middlewareReader: MiddlewareReader, functionReader: FunctionReader, paramsReader: ParameterReader);
    setupFramework(container: HubContainer): ControllerLoader;
    private setupRouteReader(container);
    private setupMiddlewareReader(container);
    private setupFunctionReader(container);
    private setupParamsReader(container);
    private setupInstance(symbol, instance, container);
}
